/*
 * driver.c
 *
 *  Created on: Apr 16, 2016
 *      Author: lidq
 */

#include <driver.h>

pthread_t pthddr;
driver_car car;

void driver_setup()
{
	wiringPiSetup();

	pinMode(PORT_SPEED, OUTPUT);

	car.speed = 0;

	driver_init();

	pthread_create(&pthddr, NULL, (void* (*)(void*)) &driver_run, NULL);
}

void driver_init()
{
	driver_pwm pwm;

	//停止
	printf("Init set 0.\n");
	car.speed = 0;
	driver_set_pwm(car.speed, &pwm);
	for (int i = 0; i < TIME_HZ * TIME_INIT_SECS; i++)
	{
		driver_run_pwm(&pwm);
	}

	printf("Init set finished.\n");
}

void driver_set_pwm(int speed, driver_pwm *pwm)
{
	pwm->time_m = TIME_DEP + speed;
	pwm->time_w = TIME_PWM_WIDTH - pwm->time_m;
}

void driver_run_pwm(driver_pwm *pwm)
{
	digitalWrite(PORT_SPEED, HIGH);
	usleep(pwm->time_m);

	digitalWrite(PORT_SPEED, LOW);
	usleep(pwm->time_w);
}

void driver_run()
{
	driver_pwm pwm;

	while (true)
	{
		driver_set_pwm(car.speed, &pwm);
		driver_run_pwm(&pwm);
	}
}

void driver_set_speed(int speed)
{
	car.speed = speed;
}

int driver_abs(int val)
{
	if (val < 0)
	{
		return -val;
	}
	return val;
}
