/*
 * driver.h
 *
 *  Created on: Apr 16, 2016
 *      Author: lidq
 */

#ifndef _INCLUDE_DRIVER_H_
#define _INCLUDE_DRIVER_H_

#include <typedef.h>
#include <engine.h>
#include <wiringPi.h>

#define TIME_INIT_SECS		(3)
#define TIME_ONE_SEC		(1000000)
#define TIME_PWM_WIDTH		(2000)
#define TIME_HZ				(500)
#define TIME_DEP			(1500)
#define PORT_SPEED	  		(0)

typedef struct
{
	int time_w;
	int time_m;
} driver_pwm;

typedef struct
{
	int speed;
} driver_car;

void driver_setup();

void driver_init();

void driver_set_pwm(int speed, driver_pwm *pwm);

void driver_run_pwm(driver_pwm *pwm);

void driver_set_speed(int speed);

void driver_run();

int driver_abs(int val);

#endif /* INCLUDE_DRIVER_H_ */
