/*
 * engine.h
 *
 *  Created on: Apr 12, 2016
 *      Author: lidq
 */

#ifndef SRC_ENGINE_H_
#define SRC_ENGINE_H_

#include <signal.h>
#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <typedef.h>
#include <driver.h>
#include <semaphore.h>
#include <if_mpu6050.h>
//ms
#define ENG_TIMER					(1)
//ms
#define ENV_TIMER					(2)

#define MAX_SPEED					(495)
#define CRITICAL_SPEED_MIN			(0.0)
#define CRITICAL_SPEED_F			(0)
#define CRITICAL_SPEED_B			(-0)

typedef struct
{
	double dx;
	double dy;
	double dz;

	double x;
	double y;
	double z;

	double ax;
	double ay;
	double az;

	double vel;
	double acc;
} s_engine;

void engine_start();

void engine_test();

void engine_exception();

void engine_reset(s_engine *e);

void engine_balance();

void engine_move(s_engine *e);

void engine_rechk_speed(s_engine *e);

double engine_pid(double et, double et_1, double et_2);

#endif /* SRC_ENGINE_H_ */
